<template>
	<view class="app">
		<view class="main">			
			<view class="cu-card list">
			<block v-for="(item,index) in listss" v-bind:key="index">
				<view class="cu-item du-item shadow u-rela"  style="overflow:hidden;">		
					<!-- <view class="content">
						<text class="text-grey margin-left-sm text-df">原料编号</text>
						<text
							class="text-black margin-left text-df">{{item.materialCode}}</text>
					</view>	 -->
					<view class="content">
						<text class="text-grey margin-left-sm text-df">原料代码</text>
						<text
							class="text-black margin-left text-df">{{item.sn}}</text>
					</view>	
					<view class="content">
						<text class="text-grey margin-left-sm text-df">原料名称</text>
						<text
							class="text-black margin-left text-df">{{item.type}}</text>
					</view>		
					<view class="content">
						<text class="text-grey margin-left-sm text-df">原料批号</text>
						<text   class="text-black margin-left text-df">{{item.code}}</text>
					</view>
					<view class="content">
						<text class="text-grey margin-left-sm text-df">相位</text>
						<text class="text-black margin-left text-df">{{item.img}}</text>
					</view>
					<view class="content">
						<text class="text-grey margin-left-sm text-df"></text>
						
						<text   class="text-black margin-left text-df" style="flex:0.5">
							<button class="_btn"  @click="weighPrintHandle(item)"  >称量打印</button>
						</text>
					</view>

				</view>
				
			</block>
			</view>
			<view v-if="maskShow" class="uni-mask" @touchmove.stop.prevent="moveHandle" @click="maskclose">
				<scroll-view class="uni-scroll_box" scroll-y @touchmove.stop.prevent="moveHandle" @click.stop="moveHandle">
					<view
						class="uni-list-box"
						v-for="(item, index) in list"
						:key="index"
						@click="tapQuery(item)"
					>
						<view>
							<view class="uni-list_name">名称：{{ item.name }}</view>
							<view class="uni-list_item">UUID:{{ item.address }}</view>
						</view>
					</view>
				</scroll-view>
			</view>
			<uni-fab :pattern="pattern" horizontal="right" vertical="bottom" :popMenu="false" @fabClick="searchDevice" :doc="doc">
			</uni-fab>
							
		</view>
	</view>
</template>
<script>
	const jcapi = uni.requireNativePlugin("JCSDK-JCApiModule");
	// 二维码类型
	const QrCodeType = {
		QrCode: 31,
		PDF417: 32,
		DataMatrix: 33,
		AZTEC: 34
	}
	
	// 线条类型
	const LineType = {
		Solid: 1, // 实线
		Dotted: 2, // 虚线（默认虚实1:1相间）
	}
	
	// 换行方式
	const LineModeType = {
		Justified: 1, // 宽高固定，内容自适应（字号/字间距/行间距按比例缩放）
		AutoHeight: 2, // 宽度固定，高度自适应
		Fixed: 4, // 宽高固定，超出部分裁剪
		Adapt: 6, // 宽高固定，内容超过时预设宽高自动缩小
	}
	
	export default {
		onLoad() {
			let _this = this;
			// 初始化SDK
			jcapi.initSDK()
			// 监听页码回调
			jcapi.didReadPrintCountInfo(function(r) {
				console.log(r)
			})
			
			// 监听错误回调
			jcapi.didReadPrintErrorInfo(function(r) {
				console.log(r)
				if(r.code == 23) {
					// 打印机断开连接
					_this.connectedDevice = null
				}
				uni.showToast({
					icon: 'none',
					title: JSON.stringify(r),
					duration: 2 * 1000
				})
			})
		},
		onShow() {
		},
		onNavigationBarButtonTap(e) {
			uni.scanCode({
				success: res => {
					try {
						const result = JSON.parse(res.result)
					
					} catch (e) {}
				}
			});
		},
		data() {	
			
			return {
				//打印数据
				listss:[
					{
						sn:"2024GY-010070",
						type:"干变高压线圈",
						orderNo:"2024061200010",
						img:"CS03",
						typeTwo:"CS03",
						ptodect:"刘如根,戴元海,董迎赛",
						date:"2024-06-10"
					}
				],
				//打印相关
				doc:"蓝牙",
				pattern: {
					color: '#7A7E83',
					backgroundColor: '#fff',
					selectedColor: '#007AFF',
					buttonColor: '#007AFF',
					iconColor: '#fff'
				},
				maskShow: false,
				list:[],//蓝牙设备数据
				printDensity: 5,
				labelType: 1,
				printMode: 2,//printModeData: [{name : '热敏', value: 1}, {name: '热转印', value: 2}],
			}
		},
		computed:{
		},
		methods: {
			moveHandle() {},
			maskclose() {
				this.maskShow = false;
			},
			searchDevice(){
				let _this = this
				uni.openBluetoothAdapter({ // 确认蓝牙是否打开
					success(r) {
						uni.showLoading({
							title: "搜索中..."
						})
						// 未授予蓝牙相关权限和未打开手机定位会搜索不到设备
						jcapi.getBluetoothDevices(function(r){
							console.log("device:" + JSON.stringify(r))
							// 搜索到设备回调
							uni.hideLoading()
							_this.list = r;
							_this.maskShow = true	
						})
					},
					fail(e) {
						uni.showModal({
							confirmText: "打开蓝牙失败"
						})
						console.log("开启蓝牙设备失败" + e)
					}
				})
			},
			tapQuery(item) {
				this.maskShow = false
				// 连接打印机
				let _this = this;
				jcapi.openPrinterByDevice({
					address: item.address,
					name: item.name,
					deviceType: item.deviceType // 设备类型：0-蓝牙，1-网络
				}, function(r) {
					uni.showToast({
						title: (r.code == 0) ? "连接成功" : "连接失败",
						duration: 2 * 1000
					})
					if(r.code == 0) {
						_this.connectedDevice = item
					}
				})
			},
			weighPrintHandle(item)
			{
				this.printQrCode()
			},
			//打印二维码
			printQrCode() {
				// 初始化画板
				jcapi.initDrawingBoard({
					width: 50,
					height: 100,
					rotate: 0
				});
				// // 绘制二维码
				var jsonString = JSON.stringify(this.listss[0]);
				jcapi.drawLabelQrCode({
					x: 17,
					y: 74,
					width: 20,
					height: 20,
					value: jsonString,
					rotate: 0,
					codeType: QrCodeType.QrCode,
				});
				//绘制横线
				jcapi.drawLabelLine({
					x: 4,
					y: 1,
					width: 46,
					height: 0.5,
					rotate: 0,
					lineType: LineType.Solid // 实线1
				});
				
				jcapi.drawLabelLine({
					x:4,
					y: 11,
					width: 46,
					height: 0.5,
					rotate: 0,
					lineType: LineType.Solid // 实线2
				});
				
				jcapi.drawLabelLine({
					x: 4,
					y: 21,
					width: 46,
					height: 0.5,
					rotate: 0,
					lineType: LineType.Solid // 实线3
				});
				
				jcapi.drawLabelLine({
					x: 4,
					y: 31,
					width: 46,
					height: 0.5,
					rotate: 0,
					lineType: LineType.Solid // 实线4
				});
				
				jcapi.drawLabelLine({
					x: 4,
					y: 41,
					width: 46,
					height: 0.5,
					rotate: 0,
					lineType: LineType.Solid // 实线5
				});
				
				jcapi.drawLabelLine({
					x: 4,
					y: 51,
					width: 46,
					height:0.5,
					rotate: 0,
					lineType: LineType.Solid // 实线6
				});
				
				jcapi.drawLabelLine({
					x:4,
					y: 61,
					width: 46,
					height: 0.5,
					rotate: 0,
					lineType: LineType.Solid // 实线7
				});
				
				jcapi.drawLabelLine({
					x: 4,
					y: 71,
					width: 46,
					height: 0.5,
					rotate: 0,
					lineType: LineType.Solid // 实线8
				});
				
				jcapi.drawLabelLine({
					x: 4,
					y: 98,
					width: 46,
					height: 0.5,
					rotate: 0,
					lineType: LineType.Solid // 实线9
				});
				
					//绘制竖线
					jcapi.drawLabelLine({
						x: 4,
						y: 1,
						width: 0.5,
						height: 97,
						rotate: 0,
						lineType: LineType.Solid // 实线
					});
					
					
					jcapi.drawLabelLine({
						x: 20,
						y: 1,
						width: 0.5,
						height: 70,
						rotate: 0,
						lineType: LineType.Solid // 实线9
					});
					
					
					jcapi.drawLabelLine({
						x: 48.5,
						y: 1,
						width: 0.5,
						height: 97,
						rotate: 0,
						lineType: LineType.Solid // 实线9
					});
					
				// 	//绘制文字
					jcapi.drawLabelText({
						x:1,
						y:4,
						width:20,
						height: 12,
						value: "编 号:",
						fontSize: 3.6,
						rotate: 0,
						lineMode: LineModeType.AutoHeight,
						lineSpace: 0,
						letterSpace: 0,
						textAlignHorizontal: 1,
						textAlignVertical: 1,
					})
					
					jcapi.drawLabelText({
						x:5,
						y:14,
						width:12,
						height: 20,
						value: "类 型:",
						fontSize:3.6,
						rotate: 0,
						lineMode: LineModeType.AutoHeight,
						lineSpace: 0,
						letterSpace: 0,
						textAlignHorizontal: 1,
						textAlignVertical: 1,
					})
					
					jcapi.drawLabelText({
						x:5,
						y:24,
						width:12,
						height: 22,
						value: "工单号:",
						fontSize: 3.6,
						rotate: 0,
						lineMode: LineModeType.AutoHeight,
						lineSpace: 0,
						letterSpace: 0,
						textAlignHorizontal: 1,
						textAlignVertical: 1,
					})
					
					jcapi.drawLabelText({
						x:5,
						y:34,
						width:12,
						height: 20,
						value: "图 号:",
						fontSize: 3.6,
						rotate: 0,
						lineMode: LineModeType.AutoHeight,
						lineSpace: 0,
						letterSpace: 0,
						textAlignHorizontal: 1,
						textAlignVertical: 1,
					})
					
					jcapi.drawLabelText({
						x:5,
						y:44,
						width:24,
						height: 20,
						value: "规格型号:",
						fontSize: 3.4,
						rotate: 0,
						lineMode: LineModeType.AutoHeight,
						lineSpace: 0,
						letterSpace: 0,
						textAlignHorizontal: 0,
						textAlignVertical: 1,
					})
					
					jcapi.drawLabelText({
						x:5,
						y:54,
						width:12,
						height: 22,
						value: "生产人:",
						fontSize: 3.6,
						rotate: 0,
						lineMode: LineModeType.AutoHeight,
						lineSpace: 0,
						letterSpace: 0,
						textAlignHorizontal: 1,
						textAlignVertical: 1,
					})
					
					jcapi.drawLabelText({
						x:5,
						y:64,
						width:24,
						height: 20,
						value: "生产日期:",
						fontSize: 3.4,
						rotate: 0,
						lineMode: LineModeType.AutoHeight,
						lineSpace: 0,
						letterSpace: 0,
						textAlignHorizontal: 0,
						textAlignVertical: 1,
					})
					
					jcapi.drawLabelText({
						x:22,
						y:4,
						width:40,
						height: 12,
						value: this.listss[0].sn,
						fontSize: 3,
						rotate: 0,
						lineMode: LineModeType.AutoHeight,
						lineSpace: 0,
						letterSpace: 0,
						textAlignHorizontal: 0,
						textAlignVertical: 0,
					})
					
					jcapi.drawLabelText({
						x:22,
						y:14,
						width:40,
						height: 12,
						value: this.listss[0].type,
						fontSize: 3,
						rotate: 0,
						lineMode: LineModeType.AutoHeight,
						lineSpace: 0,
						letterSpace: 0,
						textAlignHorizontal: 0,
						textAlignVertical: 0,
					})
					
					jcapi.drawLabelText({
						x:22,
						y:24,
						width:40,
						height: 12,
						value: this.listss[0].orderNo,
						fontSize: 3,
						rotate: 0,
						lineMode: LineModeType.AutoHeight,
						lineSpace: 0,
						letterSpace: 0,
						textAlignHorizontal: 0,
						textAlignVertical: 0,
					})
					
					jcapi.drawLabelText({
						x:22,
						y:34,
						width:40,
						height: 12,
						value: this.listss[0].img,
						fontSize: 3,
						rotate: 0,
						lineMode: LineModeType.AutoHeight,
						lineSpace: 0,
						letterSpace: 0,
						textAlignHorizontal: 0,
						textAlignVertical: 0,
					})
					
					jcapi.drawLabelText({
						x:22,
						y:44,
						width:40,
						height: 12,
						value: this.listss[0].typeTwo,
						fontSize: 3,
						rotate: 0,
						lineMode: LineModeType.AutoHeight,
						lineSpace: 0,
						letterSpace: 0,
						textAlignHorizontal: 0,
						textAlignVertical: 0,
					})
					
					jcapi.drawLabelText({
						x:22,
						y:53,
						width:28,
						height: 12,
						value: this.listss[0].ptodect,
						fontSize: 3,
						rotate: 0,
						lineMode: LineModeType.AutoHeight,
						lineSpace: 0,
						letterSpace: 0,
						textAlignHorizontal: 0,
						textAlignVertical: 0,
					})
					
					jcapi.drawLabelText({
						x:22,
						y:64,
						width:40,
						height: 12,
						value: this.listss[0].date,
						fontSize: 3,
						rotate: 0,
						lineMode: LineModeType.AutoHeight,
						lineSpace: 0,
						letterSpace: 0,
						textAlignHorizontal: 0,
						textAlignVertical: 0,
					})
				
				
				// 生成打印数据
				let imageJsonObj = jcapi.generateLabelJson()
				// 设置打印任务
				jcapi.startJob({
					totalCount: 1,
					density: this.printDensity,
					labelType: this.labelType,
					printMode: this.printMode,
				},function(r){
					if(r.code == 0) {
						// 打印数据
						jcapi.printData(imageJsonObj, {
							"printQuantity": 1,
						}, function(r) {
							if (r.code == 0) {
								console.log("打印成功")
							} else {
								console.log("打印失败")
							}
						})
					} else {
						console.log("设置打印任务失败")
					}
				})
			}, 
		}
	}
</script>

<style scoped>
	
	
	>>>.cu-custom .cu-bar
	{
		background: #3281FF !important;
		height: 44px;
		height: calc(44px + constant(safe-area-inset-top));
		height: calc(44px + env(safe-area-inset-top));
		padding: 7px 3px;
		padding-top: calc(7px + constant(safe-area-inset-top));
		padding-top: calc(7px + env(safe-area-inset-top));
	}
	
	.content
	{	display: flex;
		flex-direction: row;
		padding: 0 10rpx;}
			
	.content .text-grey
	{
		flex:0.8
	}

	.content .text-black
	{
		flex:2;
		text-align: right;
	}

	.filter-content {
		overflow-y: auto;
		/* #ifdef H5 */
		height: calc(100vh - 95px);
		/* #endif */
		/* #ifdef MP-WEIXIN */
		height: calc(100vh - 125px);
		/* #endif */
		/* #ifdef APP-VUE */
		height: calc(100vh - 145px);
		/* #endif */
		/* #ifdef APP-PLUS */
		height: calc(100vh - 55px);
		/* #endif */
	}

	uni-checkbox::before {
		content: ''
	}

	.list>.cu-item .info {
		border-top: 1px solid #f7f7f7;
		padding-top: 10px;
		margin-left: 10px;
		margin-right: 5px;
		padding-bottom: 10px;
	}

	.list>.cu-item .title {
		margin-top: 15px;
		margin-left: 10px;
		margin-right: 10px;
		margin-bottom: 10px;
	}

	.cu-card>.du-item {
		display: block;
		background-color: #FFFFFF;
		overflow: hidden;
		border-radius: 10upx;
		margin: 20upx 24upx;
	}

	.cu-card>.du-item:first-child{margin-top: 10px;}
	
/* 	.main
	{
		color:#000;
		padding:0 2%;
	} */
	
	.bottom-btn
	{
		overflow:hidden;
		margin:20px 0;
		padding:0 2%;
	}
	
	._btn
	{
		background:#3A80F4;
		color:#FFF;
		margin-bottom:20px;
	}
	
	.uni-mask {
		position: fixed;
		top: 0;
		left: 0;
		bottom: 0;
		display: flex;
		align-items: center;
		width: 100%;
		background: rgba(0, 0, 0, 0.6);
		padding: 0 30rpx;
		box-sizing: border-box;
	}
	
	
	.uni-scroll_box {
		height: 70%;
		background: #fff;
		border-radius: 20rpx;
	}
	.uni-list-box {
		margin: 0 20rpx;
		padding: 15rpx 0;
		border-bottom: 1px #f5f5f5 solid;
		box-sizing: border-box;
	}
	.uni-list:last-child {
		border: none;
	}
	.uni-list_name {
		font-size: 30rpx;
		color: #333;
	}
	.uni-list_item {
		font-size: 24rpx;
		color: #555;
		line-height: 1.5;
	}
</style>
